<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.9.1"/>
<title>Flair: flair::core::TcpSocket Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="logo_hds.png"/></td>
  <td style="padding-left: 0.5em;">
   <div id="projectname">Flair
   </div>
   <div id="projectbrief">Framework Libre Air</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.9.1 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('classflair_1_1core_1_1_tcp_socket.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="classflair_1_1core_1_1_tcp_socket-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">flair::core::TcpSocket Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>Class encapsulating a TCP socket.  
 <a href="classflair_1_1core_1_1_tcp_socket.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="_tcp_socket_8h_source.html">TcpSocket.h</a>&gt;</code></p>
<div id="dynsection-0" onclick="return toggleVisibility(this)" class="dynheader closed" style="cursor:pointer;">
  <img id="dynsection-0-trigger" src="closed.png" alt="+"/> Inheritance diagram for flair::core::TcpSocket:</div>
<div id="dynsection-0-summary" class="dynsummary" style="display:block;">
</div>
<div id="dynsection-0-content" class="dyncontent" style="display:none;">
 <div class="center">
  <img src="classflair_1_1core_1_1_tcp_socket.png" usemap="#flair::core::TcpSocket_map" alt=""/>
  <map id="flair::core::TcpSocket_map" name="flair::core::TcpSocket_map">
<area href="classflair_1_1core_1_1_connected_socket.html" title="Interface class encapsulating a connected socket. Preserves packets order and guaranty delivery..." alt="flair::core::ConnectedSocket" shape="rect" coords="0,56,171,80"/>
<area href="classflair_1_1core_1_1_object.html" title="Base class for all Framework&#39;s classes. " alt="flair::core::Object" shape="rect" coords="0,0,171,24"/>
</map>
 </div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:aecfbf8141419a463979464307d8c31f4"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aecfbf8141419a463979464307d8c31f4"></a>
&#160;</td><td class="memItemRight" valign="bottom"><b>TcpSocket</b> (const <a class="el" href="classflair_1_1core_1_1_object.html">Object</a> *parent, const std::string name, bool blockOnSend=false, bool blockOnReceive=true)</td></tr>
<tr class="separator:aecfbf8141419a463979464307d8c31f4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7eaffe48d70e5119182bdb5846c6889d"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_tcp_socket.html#a7eaffe48d70e5119182bdb5846c6889d">Listen</a> (const unsigned int port, const std::string localAddress=&quot;ANY&quot;)</td></tr>
<tr class="memdesc:a7eaffe48d70e5119182bdb5846c6889d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a socket which listens on a specific port/address.  <a href="#a7eaffe48d70e5119182bdb5846c6889d">More...</a><br /></td></tr>
<tr class="separator:a7eaffe48d70e5119182bdb5846c6889d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af3ea9a03fb31fe36b604060e9386d617"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classflair_1_1core_1_1_tcp_socket.html">TcpSocket</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_tcp_socket.html#af3ea9a03fb31fe36b604060e9386d617">Accept</a> (<a class="el" href="namespaceflair_1_1core.html#acc0fa041e08ecf73b2d1d723c339a736">Time</a> timeout=TIME_INFINITE)</td></tr>
<tr class="memdesc:af3ea9a03fb31fe36b604060e9386d617"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a socket on a new incoming connexion.  <a href="#af3ea9a03fb31fe36b604060e9386d617">More...</a><br /></td></tr>
<tr class="separator:af3ea9a03fb31fe36b604060e9386d617"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aea4dd2ff49fc3e2ba8a3afcccedbc4af"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_tcp_socket.html#aea4dd2ff49fc3e2ba8a3afcccedbc4af">Connect</a> (const unsigned int distantPort, const std::string distantAddress, <a class="el" href="namespaceflair_1_1core.html#acc0fa041e08ecf73b2d1d723c339a736">Time</a> timeout=TIME_INFINITE)</td></tr>
<tr class="memdesc:aea4dd2ff49fc3e2ba8a3afcccedbc4af"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a socket connected to a distant host.  <a href="#aea4dd2ff49fc3e2ba8a3afcccedbc4af">More...</a><br /></td></tr>
<tr class="separator:aea4dd2ff49fc3e2ba8a3afcccedbc4af"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a35141127ad1e1fd921f5ca91e2341674"><td class="memItemLeft" align="right" valign="top">ssize_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_tcp_socket.html#a35141127ad1e1fd921f5ca91e2341674">SendMessage</a> (const char *message, size_t message_len, <a class="el" href="namespaceflair_1_1core.html#acc0fa041e08ecf73b2d1d723c339a736">Time</a> timeout=TIME_INFINITE)</td></tr>
<tr class="memdesc:a35141127ad1e1fd921f5ca91e2341674"><td class="mdescLeft">&#160;</td><td class="mdescRight">Send a message waiting up to timeout ns.  <a href="#a35141127ad1e1fd921f5ca91e2341674">More...</a><br /></td></tr>
<tr class="separator:a35141127ad1e1fd921f5ca91e2341674"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a843ce6bee190e7840ca5554654ed580d"><td class="memItemLeft" align="right" valign="top">ssize_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_tcp_socket.html#a843ce6bee190e7840ca5554654ed580d">RecvMessage</a> (char *buf, size_t buf_len, <a class="el" href="namespaceflair_1_1core.html#acc0fa041e08ecf73b2d1d723c339a736">Time</a> timeout=TIME_INFINITE)</td></tr>
<tr class="memdesc:a843ce6bee190e7840ca5554654ed580d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Receive a message.  <a href="#a843ce6bee190e7840ca5554654ed580d">More...</a><br /></td></tr>
<tr class="separator:a843ce6bee190e7840ca5554654ed580d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a94921895eb0b474e967d611d78d630e2"><td class="memItemLeft" align="right" valign="top">uint16_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_tcp_socket.html#a94921895eb0b474e967d611d78d630e2">NetworkToHost16</a> (uint16_t data)</td></tr>
<tr class="memdesc:a94921895eb0b474e967d611d78d630e2"><td class="mdescLeft">&#160;</td><td class="mdescRight">! See Socket.h for a more generic implementation of network/host endianness  <a href="#a94921895eb0b474e967d611d78d630e2">More...</a><br /></td></tr>
<tr class="separator:a94921895eb0b474e967d611d78d630e2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a85ce14fc3ef83d4ddee6a80e79ade3e4"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a85ce14fc3ef83d4ddee6a80e79ade3e4"></a>
uint16_t&#160;</td><td class="memItemRight" valign="bottom"><b>HostToNetwork16</b> (uint16_t data)</td></tr>
<tr class="separator:a85ce14fc3ef83d4ddee6a80e79ade3e4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3eb6e2f90a6babfb95e4b38825673ba8"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a3eb6e2f90a6babfb95e4b38825673ba8"></a>
uint32_t&#160;</td><td class="memItemRight" valign="bottom"><b>NetworkToHost32</b> (uint32_t data)</td></tr>
<tr class="separator:a3eb6e2f90a6babfb95e4b38825673ba8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab74f735dfe4a984ee6940cd0c68f1b6e"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ab74f735dfe4a984ee6940cd0c68f1b6e"></a>
uint32_t&#160;</td><td class="memItemRight" valign="bottom"><b>HostToNetwork32</b> (uint32_t data)</td></tr>
<tr class="separator:ab74f735dfe4a984ee6940cd0c68f1b6e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classflair_1_1core_1_1_connected_socket"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classflair_1_1core_1_1_connected_socket')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classflair_1_1core_1_1_connected_socket.html">flair::core::ConnectedSocket</a></td></tr>
<tr class="memitem:a61c0bbd4147f994cc2f0276cc6982447 inherit pub_methods_classflair_1_1core_1_1_connected_socket"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_connected_socket.html#a61c0bbd4147f994cc2f0276cc6982447">ConnectedSocket</a> (const <a class="el" href="classflair_1_1core_1_1_object.html">Object</a> *parent, const std::string name)</td></tr>
<tr class="memdesc:a61c0bbd4147f994cc2f0276cc6982447 inherit pub_methods_classflair_1_1core_1_1_connected_socket"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructor.  <a href="#a61c0bbd4147f994cc2f0276cc6982447">More...</a><br /></td></tr>
<tr class="separator:a61c0bbd4147f994cc2f0276cc6982447 inherit pub_methods_classflair_1_1core_1_1_connected_socket"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad4e96a4fead5a5a1c038a31fa7dfd36b inherit pub_methods_classflair_1_1core_1_1_connected_socket"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_connected_socket.html#ad4e96a4fead5a5a1c038a31fa7dfd36b">~ConnectedSocket</a> ()</td></tr>
<tr class="memdesc:ad4e96a4fead5a5a1c038a31fa7dfd36b inherit pub_methods_classflair_1_1core_1_1_connected_socket"><td class="mdescLeft">&#160;</td><td class="mdescRight">Destructor.  <a href="#ad4e96a4fead5a5a1c038a31fa7dfd36b">More...</a><br /></td></tr>
<tr class="separator:ad4e96a4fead5a5a1c038a31fa7dfd36b inherit pub_methods_classflair_1_1core_1_1_connected_socket"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0b9c506b8cb481d90e00c487bf48a169 inherit pub_methods_classflair_1_1core_1_1_connected_socket"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a0b9c506b8cb481d90e00c487bf48a169"></a>
std::string&#160;</td><td class="memItemRight" valign="bottom"><b>ReadString</b> (const size_t &amp;stringLength, <a class="el" href="namespaceflair_1_1core.html#acc0fa041e08ecf73b2d1d723c339a736">Time</a> timeout)</td></tr>
<tr class="separator:a0b9c506b8cb481d90e00c487bf48a169 inherit pub_methods_classflair_1_1core_1_1_connected_socket"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac3de6fad3ddd34fb7f9928e04abdc746 inherit pub_methods_classflair_1_1core_1_1_connected_socket"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ac3de6fad3ddd34fb7f9928e04abdc746"></a>
uint16_t&#160;</td><td class="memItemRight" valign="bottom"><b>ReadUInt16</b> (<a class="el" href="namespaceflair_1_1core.html#acc0fa041e08ecf73b2d1d723c339a736">Time</a> const &amp;timeout)</td></tr>
<tr class="separator:ac3de6fad3ddd34fb7f9928e04abdc746 inherit pub_methods_classflair_1_1core_1_1_connected_socket"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aad9de20aee680674861f6ee216a12c82 inherit pub_methods_classflair_1_1core_1_1_connected_socket"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aad9de20aee680674861f6ee216a12c82"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>WriteUInt16</b> (uint16_t const &amp;data, <a class="el" href="namespaceflair_1_1core.html#acc0fa041e08ecf73b2d1d723c339a736">Time</a> const &amp;timeout)</td></tr>
<tr class="separator:aad9de20aee680674861f6ee216a12c82 inherit pub_methods_classflair_1_1core_1_1_connected_socket"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae718da5dcb14ba66ef03c645c922b9cb inherit pub_methods_classflair_1_1core_1_1_connected_socket"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ae718da5dcb14ba66ef03c645c922b9cb"></a>
uint32_t&#160;</td><td class="memItemRight" valign="bottom"><b>ReadUInt32</b> (<a class="el" href="namespaceflair_1_1core.html#acc0fa041e08ecf73b2d1d723c339a736">Time</a> const &amp;timeout)</td></tr>
<tr class="separator:ae718da5dcb14ba66ef03c645c922b9cb inherit pub_methods_classflair_1_1core_1_1_connected_socket"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a74f5b08f78dd97aea132bcdfe2cb191c inherit pub_methods_classflair_1_1core_1_1_connected_socket"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a74f5b08f78dd97aea132bcdfe2cb191c"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>WriteUInt32</b> (uint32_t const &amp;data, <a class="el" href="namespaceflair_1_1core.html#acc0fa041e08ecf73b2d1d723c339a736">Time</a> const &amp;timeout)</td></tr>
<tr class="separator:a74f5b08f78dd97aea132bcdfe2cb191c inherit pub_methods_classflair_1_1core_1_1_connected_socket"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classflair_1_1core_1_1_object"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classflair_1_1core_1_1_object')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classflair_1_1core_1_1_object.html">flair::core::Object</a></td></tr>
<tr class="memitem:aec92383fd5bf68d9df10414862b7e95c inherit pub_methods_classflair_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_object.html#aec92383fd5bf68d9df10414862b7e95c">Object</a> (const <a class="el" href="classflair_1_1core_1_1_object.html">Object</a> *parent=NULL, std::string name=&quot;&quot;, std::string type=&quot;&quot;)</td></tr>
<tr class="memdesc:aec92383fd5bf68d9df10414862b7e95c inherit pub_methods_classflair_1_1core_1_1_object"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructor.  <a href="#aec92383fd5bf68d9df10414862b7e95c">More...</a><br /></td></tr>
<tr class="separator:aec92383fd5bf68d9df10414862b7e95c inherit pub_methods_classflair_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa2bde0e6677bbef705c96c93cb06ad09 inherit pub_methods_classflair_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_object.html#aa2bde0e6677bbef705c96c93cb06ad09">~Object</a> ()</td></tr>
<tr class="memdesc:aa2bde0e6677bbef705c96c93cb06ad09 inherit pub_methods_classflair_1_1core_1_1_object"><td class="mdescLeft">&#160;</td><td class="mdescRight">Destructor.  <a href="#aa2bde0e6677bbef705c96c93cb06ad09">More...</a><br /></td></tr>
<tr class="separator:aa2bde0e6677bbef705c96c93cb06ad09 inherit pub_methods_classflair_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9b0344dff7e1c05424d9152c8274523a inherit pub_methods_classflair_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_object.html#a9b0344dff7e1c05424d9152c8274523a">ObjectName</a> (void) const </td></tr>
<tr class="memdesc:a9b0344dff7e1c05424d9152c8274523a inherit pub_methods_classflair_1_1core_1_1_object"><td class="mdescLeft">&#160;</td><td class="mdescRight">Name.  <a href="#a9b0344dff7e1c05424d9152c8274523a">More...</a><br /></td></tr>
<tr class="separator:a9b0344dff7e1c05424d9152c8274523a inherit pub_methods_classflair_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a609a250ec037fbcaf8957c8f1dcbfc53 inherit pub_methods_classflair_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_object.html#a609a250ec037fbcaf8957c8f1dcbfc53">ObjectType</a> (void) const </td></tr>
<tr class="memdesc:a609a250ec037fbcaf8957c8f1dcbfc53 inherit pub_methods_classflair_1_1core_1_1_object"><td class="mdescLeft">&#160;</td><td class="mdescRight">Type.  <a href="#a609a250ec037fbcaf8957c8f1dcbfc53">More...</a><br /></td></tr>
<tr class="separator:a609a250ec037fbcaf8957c8f1dcbfc53 inherit pub_methods_classflair_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a360c112cc3017a5152ebf6e84d2efa70 inherit pub_methods_classflair_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top">const <a class="el" href="classflair_1_1core_1_1_object.html">Object</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_object.html#a360c112cc3017a5152ebf6e84d2efa70">Parent</a> (void) const </td></tr>
<tr class="memdesc:a360c112cc3017a5152ebf6e84d2efa70 inherit pub_methods_classflair_1_1core_1_1_object"><td class="mdescLeft">&#160;</td><td class="mdescRight">Parent.  <a href="#a360c112cc3017a5152ebf6e84d2efa70">More...</a><br /></td></tr>
<tr class="separator:a360c112cc3017a5152ebf6e84d2efa70 inherit pub_methods_classflair_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae22db4d723ec2d50b3ba48f26a6a770c inherit pub_methods_classflair_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top">std::vector&lt; const <a class="el" href="classflair_1_1core_1_1_object.html">Object</a> * &gt; *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_object.html#ae22db4d723ec2d50b3ba48f26a6a770c">TypeChilds</a> (void) const </td></tr>
<tr class="memdesc:ae22db4d723ec2d50b3ba48f26a6a770c inherit pub_methods_classflair_1_1core_1_1_object"><td class="mdescLeft">&#160;</td><td class="mdescRight">Childs of the same type.  <a href="#ae22db4d723ec2d50b3ba48f26a6a770c">More...</a><br /></td></tr>
<tr class="separator:ae22db4d723ec2d50b3ba48f26a6a770c inherit pub_methods_classflair_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a344f81cd35805a9501098bf727ac1a10 inherit pub_methods_classflair_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top">std::vector&lt; const <a class="el" href="classflair_1_1core_1_1_object.html">Object</a> * &gt; *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_object.html#a344f81cd35805a9501098bf727ac1a10">Childs</a> (void) const </td></tr>
<tr class="memdesc:a344f81cd35805a9501098bf727ac1a10 inherit pub_methods_classflair_1_1core_1_1_object"><td class="mdescLeft">&#160;</td><td class="mdescRight">Childs.  <a href="#a344f81cd35805a9501098bf727ac1a10">More...</a><br /></td></tr>
<tr class="separator:a344f81cd35805a9501098bf727ac1a10 inherit pub_methods_classflair_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af001feba14fc053aa778e61080a0b4cf inherit pub_methods_classflair_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_object.html#af001feba14fc053aa778e61080a0b4cf">Information</a> (const char *function, int line, const char *format,...) const </td></tr>
<tr class="memdesc:af001feba14fc053aa778e61080a0b4cf inherit pub_methods_classflair_1_1core_1_1_object"><td class="mdescLeft">&#160;</td><td class="mdescRight">Formatted information.  <a href="#af001feba14fc053aa778e61080a0b4cf">More...</a><br /></td></tr>
<tr class="separator:af001feba14fc053aa778e61080a0b4cf inherit pub_methods_classflair_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a168b18451b2ee6126e1e81d452005ff6 inherit pub_methods_classflair_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_object.html#a168b18451b2ee6126e1e81d452005ff6">Warning</a> (const char *function, const char *format,...) const </td></tr>
<tr class="memdesc:a168b18451b2ee6126e1e81d452005ff6 inherit pub_methods_classflair_1_1core_1_1_object"><td class="mdescLeft">&#160;</td><td class="mdescRight">Formatted warning.  <a href="#a168b18451b2ee6126e1e81d452005ff6">More...</a><br /></td></tr>
<tr class="separator:a168b18451b2ee6126e1e81d452005ff6 inherit pub_methods_classflair_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3ca9694d29ec2b0491739879685df5ca inherit pub_methods_classflair_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_object.html#a3ca9694d29ec2b0491739879685df5ca">Error</a> (const char *function, const char *format,...) const </td></tr>
<tr class="memdesc:a3ca9694d29ec2b0491739879685df5ca inherit pub_methods_classflair_1_1core_1_1_object"><td class="mdescLeft">&#160;</td><td class="mdescRight">Formatted error.  <a href="#a3ca9694d29ec2b0491739879685df5ca">More...</a><br /></td></tr>
<tr class="separator:a3ca9694d29ec2b0491739879685df5ca inherit pub_methods_classflair_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a36cdd7f556e78b1bddd1d1fe4264bb85 inherit pub_methods_classflair_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_object.html#a36cdd7f556e78b1bddd1d1fe4264bb85">ErrorOccured</a> (bool recursive=true) const </td></tr>
<tr class="memdesc:a36cdd7f556e78b1bddd1d1fe4264bb85 inherit pub_methods_classflair_1_1core_1_1_object"><td class="mdescLeft">&#160;</td><td class="mdescRight">Has an errror occured?  <a href="#a36cdd7f556e78b1bddd1d1fe4264bb85">More...</a><br /></td></tr>
<tr class="separator:a36cdd7f556e78b1bddd1d1fe4264bb85 inherit pub_methods_classflair_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="inherited"></a>
Additional Inherited Members</h2></td></tr>
<tr class="inherit_header pub_types_classflair_1_1core_1_1_object"><td colspan="2" onclick="javascript:toggleInherit('pub_types_classflair_1_1core_1_1_object')"><img src="closed.png" alt="-"/>&#160;Public Types inherited from <a class="el" href="classflair_1_1core_1_1_object.html">flair::core::Object</a></td></tr>
<tr class="memitem:aed5fccda511f97487040fed29f4efc97 inherit pub_types_classflair_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aed5fccda511f97487040fed29f4efc97"></a>enum &#160;</td><td class="memItemRight" valign="bottom"><b>color_t</b> { <b>Auto</b> = 0, 
<b>Red</b> = 31, 
<b>Green</b> = 32, 
<b>Orange</b> = 33
 }</td></tr>
<tr class="separator:aed5fccda511f97487040fed29f4efc97 inherit pub_types_classflair_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Class encapsulating a TCP socket. </p>
</div><h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="a7eaffe48d70e5119182bdb5846c6889d"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void flair::core::TcpSocket::Listen </td>
          <td>(</td>
          <td class="paramtype">const unsigned int&#160;</td>
          <td class="paramname"><em>port</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string&#160;</td>
          <td class="paramname"><em>localAddress</em> = <code>&quot;ANY&quot;</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns a socket which listens on a specific port/address. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">const</td><td>Object* parentObject </td></tr>
    <tr><td class="paramname">const</td><td>string name </td></tr>
    <tr><td class="paramname">unsigned</td><td>int port </td></tr>
    <tr><td class="paramname">const</td><td>localAddress (defaults to any) </td></tr>
  </table>
  </dd>
</dl>

<p>Implements <a class="el" href="classflair_1_1core_1_1_connected_socket.html#ab522b80d805132cd0762f44852085613">flair::core::ConnectedSocket</a>.</p>

</div>
</div>
<a class="anchor" id="af3ea9a03fb31fe36b604060e9386d617"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classflair_1_1core_1_1_tcp_socket.html">TcpSocket</a>* flair::core::TcpSocket::Accept </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceflair_1_1core.html#acc0fa041e08ecf73b2d1d723c339a736">Time</a>&#160;</td>
          <td class="paramname"><em>timeout</em> = <code>TIME_INFINITE</code></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns a socket on a new incoming connexion. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">timeout</td><td>timeout (in nanoseconds) </td></tr>
  </table>
  </dd>
</dl>

<p>Implements <a class="el" href="classflair_1_1core_1_1_connected_socket.html#a8c89979efaba9298d32c58a07021f2e0">flair::core::ConnectedSocket</a>.</p>

</div>
</div>
<a class="anchor" id="aea4dd2ff49fc3e2ba8a3afcccedbc4af"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool flair::core::TcpSocket::Connect </td>
          <td>(</td>
          <td class="paramtype">const unsigned int&#160;</td>
          <td class="paramname"><em>port</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string&#160;</td>
          <td class="paramname"><em>distantAddress</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceflair_1_1core.html#acc0fa041e08ecf73b2d1d723c339a736">Time</a>&#160;</td>
          <td class="paramname"><em>timeout</em> = <code>TIME_INFINITE</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns a socket connected to a distant host. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">const</td><td>Object* parentObject </td></tr>
    <tr><td class="paramname">const</td><td>string name </td></tr>
    <tr><td class="paramname">unsigned</td><td>int port </td></tr>
    <tr><td class="paramname">const</td><td>distantAddress </td></tr>
    <tr><td class="paramname">timeout</td><td>timeout (in nanoseconds) </td></tr>
  </table>
  </dd>
</dl>

<p>Implements <a class="el" href="classflair_1_1core_1_1_connected_socket.html#aebfdaebe07aee9b77b75d56e61fd6926">flair::core::ConnectedSocket</a>.</p>

</div>
</div>
<a class="anchor" id="a35141127ad1e1fd921f5ca91e2341674"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">ssize_t flair::core::TcpSocket::SendMessage </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>message</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>message_len</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceflair_1_1core.html#acc0fa041e08ecf73b2d1d723c339a736">Time</a>&#160;</td>
          <td class="paramname"><em>timeout</em> = <code>TIME_INFINITE</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Send a message waiting up to timeout ns. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">message</td><td>message </td></tr>
    <tr><td class="paramname">message_len</td><td>message length </td></tr>
    <tr><td class="paramname">timeout</td><td>timeout (in nanoseconds) </td></tr>
  </table>
  </dd>
</dl>

<p>Implements <a class="el" href="classflair_1_1core_1_1_connected_socket.html#aed7d5a9e49996bf672050f95f82d85b4">flair::core::ConnectedSocket</a>.</p>

</div>
</div>
<a class="anchor" id="a843ce6bee190e7840ca5554654ed580d"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">ssize_t flair::core::TcpSocket::RecvMessage </td>
          <td>(</td>
          <td class="paramtype">char *&#160;</td>
          <td class="paramname"><em>buf</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>buf_len</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceflair_1_1core.html#acc0fa041e08ecf73b2d1d723c339a736">Time</a>&#160;</td>
          <td class="paramname"><em>timeout</em> = <code>TIME_INFINITE</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Receive a message. </p>
<p>Receive a message and wait up to timeout ns. <br />
 </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">buf</td><td>buffer to put the message </td></tr>
    <tr><td class="paramname">buf_len</td><td>buffer length </td></tr>
    <tr><td class="paramname">timeout</td><td>timeout (in nanoseconds)</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>size of the received message </dd></dl>

<p>Implements <a class="el" href="classflair_1_1core_1_1_connected_socket.html#ade302ba4b2afddd6b421823a261f01c9">flair::core::ConnectedSocket</a>.</p>

</div>
</div>
<a class="anchor" id="a94921895eb0b474e967d611d78d630e2"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">uint16_t flair::core::TcpSocket::NetworkToHost16 </td>
          <td>(</td>
          <td class="paramtype">uint16_t&#160;</td>
          <td class="paramname"><em>data</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>! See Socket.h for a more generic implementation of network/host endianness </p>

<p>Implements <a class="el" href="classflair_1_1core_1_1_connected_socket.html#a01410482ffeca813adcd5240cc69292d">flair::core::ConnectedSocket</a>.</p>

</div>
</div>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="namespaceflair.html">flair</a></li><li class="navelem"><a class="el" href="namespaceflair_1_1core.html">core</a></li><li class="navelem"><a class="el" href="classflair_1_1core_1_1_tcp_socket.html">TcpSocket</a></li>
    <li class="footer">Generated on Thu Jan 31 2019 12:34:23 for Flair by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.9.1 </li>
  </ul>
</div>
</body>
</html>
